# -*- coding: utf-8 -*-
# try:
#     from urllib2 import Request, build_opener, HTTPRedirectHandler
# except ImportError:
#     from urllib.request import Request, build_opener, HTTPRedirectHandler
import sys, re
import requests
from requests.compat import urljoin
from bs4 import BeautifulSoup
# ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36'


# def httpget2(url, refer):
#     class MyHTTPRedirectHandler(HTTPRedirectHandler):
#         url = ''
#
#         def redirect_request(self, req, fp, code, msg, hdrs, newurl):
#             self.url = newurl
#             return HTTPRedirectHandler.redirect_request(self, req, fp, code, msg, hdrs, newurl)
#
#     test = MyHTTPRedirectHandler()
#     opener = build_opener(test)
#     request = Request(url)
#     request.add_header('User-Agent', ua)
#     request.add_header('Referer', refer)
#     try:
#         opener.open(request)
#         return test.url
#     except:
#         return None


def htmlparser(url, data=None):
    if data:
        r = requests.post(url, data=data)
    else:
        r = requests.get(url)
    if not r.ok:
        raise requests.HTTPError
    content = r.text
    if sys.version_info >= (2, 7, 3) and sys.version_info < (3, 0):
        return BeautifulSoup(content, 'html.parser')
    if sys.version_info >= (3, 2) and sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def video(url):
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 100'}
    suburl = soup.find('a', {'class': 'video'}).attrs['href']
    return video2(urljoin(url, suburl))


def video2(url):
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 102'}
    items = []
    for e1 in soup.find('ul', {'class': 'aside-tabbox'}).find_all('li'):
        for e2 in e1.find_all('a'):
            title = e2.getText()
            items.append({'title': title, 'url': urljoin(url, e2.attrs['href'])})
    return {'item': items}


def play(url):
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 200'}
    url2 = soup.find('iframe', {'id': 'main'}).attrs['src']
    url3 = re.search('/player/player\.php\?(.*)', url2)
    if url3:
        return {'code': '跟我说一声' + url}
        # url3 = urljoin(url, url2)
        # url2 = httpget2(url3, url)
    url3 = re.search('yunbo.html\?url=(.*)', url2)
    if url3:
        url3 = url3.group(1)
        return {'url': {'m3u8': url3}, 'header': {'Referer': url}}
    return {'code': 'localau 201'}


def sports():
    url = 'http://www.tiyu6.tv/'
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 300'}
    items = []
    for e1 in soup.find_all('li', {'class': 'gamelist'}):
        title = []
        for e2 in e1.find_all(['span', 'div']):
            if 'style' in e2.attrs and 'display:none;' in e2.attrs['style']:
                continue
            if 'style' in e2.attrs and 'text-align:center;' in e2.attrs['style']:
                continue
            t = e2.find(text=True).strip()
            if not t:
                continue
            title.append(t)
        for e2 in e1.find_all(['span', 'div']):
            if 'style' in e2.attrs and 'display:none;' in e2.attrs['style']:
                continue
            if 'style' not in e2.attrs or 'text-align:center;' not in e2.attrs['style']:
                continue
            t = e2.find(text=True).strip()
            if not t:
                continue
            title.append(t)
        title = ' '.join(title)
        suburl = e1.find('a').attrs['href']
        items.append({'title': title, 'url': urljoin(url, suburl)})
    return {'item': items}


def game(url):
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 310'}
    items = []
    e1 = soup.find('div', {'id': 'links'})
    if e1:
        for e2 in e1.find_all('a'):
            url = e2.attrs['href']
            if url[:31] == 'http://sports.localau.com/play/':
                items.append({'title': e2.getText(), 'url': url})
    return {'item': items}


def sport(url):
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 320'}
    p = soup.find('iframe', {'id': re.compile('main.*')})
    if not p:
        return {'code': 'localau 321'}
    if 'src' not in p.attrs:
        return {'code': 'localau 322'}
    url = urljoin(url, p.attrs['src'])
    id = re.search('play.html\?id=(.*)', url)
    if id:
        id = id.group(1)
        return {'url': {'m3u8': 'http://live.centerch.com/%s.m3u8' % id}}
    day = re.search('\?day=(.*)', url)
    if day:
        try:
            content = requests.get(url).text
        except:
            return {'code': 'localau 323'}
        url = re.search('playurl\s*=\s*"(.*?)"', content)
        if not url:
            return {'code': 'localau 324'}
        url = url.group(1)
        return {'url': {'m3u8': url}}
    return {'code': 'localau 325'}


def category(cat, page=1):
    url = 'http://www.localmv1.com/list/%s____%d.html' % (cat, page)
    try:
        soup = htmlparser(url)
    except:
        return {'code': 'localau 400'}
    n = soup.find('div', {'class': 'm-result-list'})
    if not n:
        return {'code': 'localau 401'}
    n = n.find('ul')
    if not n:
        return {'code': 'localau 402'}
    items = []
    for e in n.find_all('li', {'class': 'm-result-list-item'}):
        suburl = e.find('a', {'class': 'u-video'})
        if not suburl:
            continue
        if 'href' not in suburl.attrs:
            continue
        suburl = suburl.attrs['href']
        title = e.find('a', {'class': 'u-title'})
        if not title:
            continue
        items.append({'title': title.getText(), 'url': urljoin(url, suburl)})
    items.append({'title': 'Next Page', 'category': cat, 'page': page + 1})
    return {'item': items}


def search(s):
    url = 'http://www.localmv1.com/search/'
    try:
        soup = htmlparser(url, {'wd': s})
    except:
        return {'code': 'localau 500'}
    items = []
    try:
        for e1 in soup.find_all('div', {'class': 'tele_hd'}):
            e2 = e1.find('a', {'class': 'report-click'})
            if not e2:
                continue
            items.append({'title': e2.getText(), 'url': urljoin(url, e2.attrs['href']), 'video': True})
    except:
        return {'code': 'localau 501'}
    return {'item': items}
